function cluster = gcluster(dim,q)
nrow = 0;
for i = 0:q
    nrow = nchoosek(dim,i) + nrow;
end

cluster = zeros(nrow,q);
cluster(nrow,:) = 1;
cluster(1:dim,1) = 1:dim;
if q>1
    k = dim + 1;
    for i = 2:q
        m = nchoosek(1:dim,i);
        mrow = size(m,1);
        for j = 1:mrow
            cluster(k,1:i) = m(j,:);
            k = k + 1;
        end
    end
end
cluster = [(1:nrow)' cluster];
return;