function fBasis = gBasisq(X,q)
[sampsize,dim] = size(X);
ncol = 0;
for i = 0:q
    ncol = nchoosek(dim,i) + ncol;
end
fBasis = zeros(sampsize,ncol);
fBasis(:,ncol) = ones(sampsize,1);
fBasis(:,1:dim) = X;
if q>1
    k = dim + 1;
    for i = 2:q
        m = nchoosek(1:dim,i);
        mrow = size(m,1);
        for j = 1:mrow
            fBasis(:,k) = prod(X(:,m(j,:)),2);
            k = k + 1;
        end
    end
end
return;